<template>
  <!-- Control -->
  <!-- isMobile -->
  <v-form
    ref="form"
    class="pa-0 mb-1 ma-0"
  >
    <!-- <div> -->
    <div>
      <v-row class="mb-0">
        <v-col
          cols="12"
          lg="12"
          class="pt-0 pb-0 text-right white mt-1 mb-1"
          style="height: 32px"
        >
          <v-radio-group
            v-model="saleOrder.order_customer_type"
            row
            class="pl-4 mt-0 mb-0 rad-tab"
          >
            <v-radio
              label="Khách lẻ"
              value="KL"
              hide-details=""
            />
            <v-radio
              label="Khách sỉ"
              value="KS"
              hide-details=""
            />
            <v-radio
              label="CTV"
              value="CTV"
              hide-details=""
            />
          </v-radio-group>
        </v-col>
      </v-row>

      <v-tabs
        v-model="tab"
        show-arrows
        background-color="grey pa-0 ma-0"
        class="pl-0"
        dark
        grow
        active-class="teal darken-3"
        slider-color="blue"
        :scrollable="false"
        @change="onTabChange"
      >
        <!-- <v-tabs-slider color="cyan darken-4"></v-tabs-slider> -->
        <v-tab
          v-for="(tab, idx) in tabs"
          :key="tab.index"
          ripple
          class="pa-0 ma-0"
          :disabled="tab.disabled"
        >
          <v-icon medium>
            {{ tab.icon }}
          </v-icon>
          <div class="caption py-1 pa-0 ma-0">
            {{ tab.name }}
          </div>
        </v-tab>
        <v-tabs-items
          v-model="tab"
          touchless
          class=" pa-0 ma-0"
        >
          <!-- NGUOI MUA -->
          <v-tab-item class="tab-item-sale">
            <v-col
              cols="12"
              lg="12"
              md="4"
              class="light-gray pa-1"
            >
              <v-col>
                <v-col
                  cols="12"
                  lg="12"
                  class="light-gray pa-1"
                >
                  <v-combobox
                    ref="customerOrder"
                    v-model="saleOrder.customer_name"
                    :items="customerList"
                    search-input="KH Lẻ"
                    return-object
                    item-text="name"
                    label="Khách hàng (*)"
                    :rules="emptyRules"
                    required
                    clearable
                    @input="customerChange($event);statusConfirmTab($event)"
                  />
                </v-col>
                <v-col
                  cols="12"
                  lg="12"
                  class="light-gray pa-1"
                >
                  <v-text-field
                    ref="customerPhone"
                    v-model="saleOrder.customer_phone"
                    label="Số ĐT"
                    required
                    :rules="emptyRules"
                    @input="statusConfirmTab($event)"
                  />
                </v-col>
                <v-col
                  cols="12"
                  lg="6"
                  class="light-gray pa-1 btn-control-detail"
                >
                  <v-text-field
                    ref="customerAddress"
                    v-model="saleOrder.order_code"
                    label="Ngày mua"
                    required
                    disabled
                  />
                </v-col>

                <v-col
                  cols="12"
                  lg="12"
                  class="light-gray pa-1 pa-1"
                >
                  <v-text-field
                    ref="codeproduct"
                    v-model="saleOrder.customer_address"
                    label="Địa chỉ"
                    required
                    :rules="emptyRules"
                  />
                </v-col>
              </v-col>
            </v-col>
          </v-tab-item>
          <!-- San PHAM -->
          <v-tab-item class="tab-item-sale ml-4 mr-3">
            <v-col
              cols="12"
              md="12"
              class="light-gray pa-1 pa-1 mb-0 d-inline-flex"
            >
              <v-autocomplete
                id="productId"
                ref="productName"
                v-model="selectProduct.product_name"
                :items="productCboList"
                :search-input.sync="searchInput"
                return-object
                item-text="name"
                label="Tên sản phẩm (*)"
                clearable
                @change="productChange($event)"
                @input="statusConfirmTab($event)"
              >
                <template v-slot:item="data">
                  <template v-if="typeof data.item !== 'object'">
                    <v-list-item-content v-text="data.item" />
                  </template>
                  <template v-else>
                    <v-list-item-avatar>
                      <img :src="JSON.parse(data.item.img_url).thumbs">
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title class="text-bold">
                        <v-row>
                          <v-col cols="8">
                            {{ data.item.name }}
                          </v-col><v-col
                            cols="4"
                            class="text-right"
                          >
                            {{ formatPrice(data.item.wholesale_price, 0) }}
                          </v-col>
                        </v-row>
                      </v-list-item-title>
                      <v-list-item-subtitle>
                        Kho:
                        {{ data.item.quatity_inventory }}
                      </v-list-item-subtitle>
                    </v-list-item-content>
                  </template>
                </template>
              </v-autocomplete>
              <!-- <v-text-field
                  ref="Voucher"
                  class="text-right ml-4"
                  v-model="saleOrder.promotion"
                  label="Voucher"
                  width="10"

                  @change="onUpdateOrder()"
                  @input="statusConfirmTab($event)"
                /> -->
            </v-col>
            <!-- <h2>
                Mặt hàng đã chọn
                {{ saleOrder.saleOrderDetail.length }}
              </h2> -->
            <swipe-list
              ref="list"
              class="card lst-items"
              :disabled="!enabled"
              :items="saleOrder.saleOrderDetail"
              item-key="id"
              @swipeout:click="itemClick"
            >
              <template v-slot="{ item, index, revealLeft, revealRight, close }">
                <div class="card-content">
                  <v-row>
                    <v-col
                      cols="3"
                      md="3"
                      class="pr-1 pt-2"
                    >
                      <v-img
                        width="80"
                        src="https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                      />
                    </v-col>
                    <v-col
                      cols="9"
                      md="9"
                      class="pt-1 pb-0"
                    >
                      <v-row>
                        <v-col
                          cols="12"
                          md="12"
                          class="pr-1 pt-1 pb-0"
                        >
                          <!-- style content how ever you like -->
                          <h4>{{ item.product_name }} ({{ formatPrice(item.amount,0) }})</h4>
                        </v-col>
                      </v-row>
                      <v-row>
                        <v-col
                          sm="8"
                          class="pr-1 pb-0 pt-0"
                        >
                          Giá
                        </v-col>
                        <v-col
                          sm="4"
                          class="pr-1 pb-0 pt-0"
                        >
                          Số lượng
                        </v-col>
                      </v-row>
                      <v-row>
                        <v-col
                          sm="8"
                          class="pr-1 pt-0 pb-1"
                        >
                          <vue-numeric-input
                            v-model="item.price"
                            :min="1000"
                            :max="1000000"
                            :step="500"
                            align="center"
                            class="text-price"
                            size="135px"
                            @change="itemQtyChange(item)"
                          />
                        </v-col>
                        <v-col
                          sm="4"
                          class="pl-0 pt-0 pb-1 pr-4"
                        >
                          <vue-numeric-input
                            v-model="item.quanity"
                            :min="1"
                            :max="1000"
                            :step="1"
                            align="center"
                            class="text-qty"
                            size="90px"
                            @change="itemQtyChange(item)"
                          />
                        </v-col>
                      </v-row>
                    </v-col>
                  </v-row>
                </div>
                <v-divider class="dark-gray" />
              </template>
              <!-- left swipe side template and v-slot:left="{ item }" is the item clearly -->
              <!-- remove if you dont wanna have left swipe side  -->
              <!-- right swipe side template and v-slot:right"{ item }" is the item clearly -->
              <!-- remove if you dont wanna have right swipe side  -->
              <template v-slot:right="{ item }">
                <div
                  class="swipeout-action gray"
                  @click="deleteProduct(detail)"
                >
                  <v-icon color="white">
                    mdi-trash
                  </v-icon>
                  <!-- place icon here or what ever you want -->
                </div>
                <div class="swipeout-action text-center red pa-4">
                  <v-icon color="white">
                    mdi-close
                  </v-icon>
                  <!-- place icon here or what ever you want -->
                  <!-- <i class="fa fa-heart"></i> -->
                </div>
              </template>
              <template v-slot:empty>
                <div>
                  <!-- change mockSwipeList to an empty array to see this slot in action  -->
                  list is empty ( filtered or just empty ) abc
                </div>
              </template>
            </swipe-list>
          </v-tab-item>
          <!-- End san PHAM -->

          <!-- Van chuyen -->
          <v-tab-item class="tab-item-sale ml-4 mr-3">
            <v-col
              cols="12"
              class="pt-0 pb-0 mb-0"
            >
              <!-- Nguoi mua -->
              <v-col
                cols="12"
                class="text-right pa-0 ma-0"
              />
              <!-- Nguoi nhận -->
              <v-col
                cols="12"
                lg="12"
                md="4"
                class="light-gray pa-1 pa-1 mt-0 pt-0 mb-0 pb-0"
              >
                <v-row>
                  <v-col
                    cols="12"
                    lg="12"
                    sm="12"
                    class="light-gray pa-0 pa-0 d-inline-flex"
                  >
                    <v-text-field
                      ref="customerdeliveryname"
                      v-model="saleOrder.name_delivery"
                      label="Họ tên người nhận (*)"
                      :rules="emptyRules"
                      required
                      @input="statusConfirmTab($event)"
                    />
                    <v-btn
                      color="green"
                      icon
                      class="mt-5"
                      @click="insertCustomer()"
                    >
                      <v-icon> add </v-icon>
                    </v-btn>
                    <v-btn
                      color="green"
                      icon
                      class="mt-5"
                      @click="copyCustomer()"
                    >
                      <v-icon> file_copy </v-icon>
                    </v-btn>
                  </v-col>

                  <v-col
                    cols="12"
                    lg="6"
                    sm="6"
                    class="light-gray pa-1 pa-1 mt-0 pt-0 mb-0 pb-0"
                  >
                    <v-autocomplete
                      ref="refDVVC"
                      v-model="saleOrder.delivery_partner"
                      :items="DVVCList"
                      :rules="emptyRules"
                      return-object
                      item-text="name"
                      label="ĐVVC"
                      search-input.sync="GHN"
                      @input="statusConfirmTab($event)"
                    />
                  </v-col>

                  <v-col
                    cols="12"
                    lg="6"
                    sm="6"
                    class="light-gray pa-0 pa-0 pl-4"
                  >
                    <v-text-field
                      ref="phiVC"
                      v-model="saleOrder.delivery_price"
                      class="text-right"
                      label="Phí VC"
                      :rules="emptyRules"
                      @change="onUpdateOrder()"
                      @input="statusConfirmTab($event)"
                    />
                  </v-col>

                  <v-col
                    cols="12"
                    lg="6"
                    sm="6"
                    class="light-gray pa-1 pa-1 ma-0 pa-0 mt-0 pt-0"
                  >
                    <v-text-field
                      ref="codeproduct"
                      v-model="saleOrder.phone_delivery"
                      label="ĐT giao hàng"
                      required
                      :rules="emptyRules"
                    />
                  </v-col>
                  <v-col
                    cols="12"
                    lg="6"
                    sm="6"
                    class="light-gray pa-1 pa-1 ma-0 pa-0 mt-0 pt-0"
                  >
                    <v-text-field
                      ref="codeproduct"
                      v-model="saleOrder.delivery_tracking"
                      label="Mã vận đơn"
                    />
                  </v-col>
                  <v-col
                    cols="12"
                    lg="5"
                    class="light-gray pa-1 pa-1 mb-0"
                  >
                    <v-text-field
                      v-show="false"
                      ref="codeproduct"
                      v-model="saleOrder.time_delivery"
                      label="Thời gian giao hàng"
                    />
                  </v-col>
                  <v-col
                    cols="12"
                    lg="12"
                    class="light-gray pa-1 pa-1"
                  >
                    <v-text-field
                      ref="codeproduct"
                      v-model="saleOrder.address_delivery"
                      label="Địa chỉ"
                      required
                      :rules="emptyRules"
                    />
                  </v-col>
                </v-row>
              </v-col>
              <!-- DVVC -->
              <v-col
                cols="12"
                lg="12"
                md="3"
                class="light-gray pa-1 pa-1"
              >
                <v-row>
                  <v-col
                    cols="12"
                    lg="12"
                    class="light-gray pa-1 pa-1"
                  >
                    <v-text-field
                      ref="refdelUrl"
                      v-model="saleOrder.delivery_url"
                      label="Link"
                    />
                  </v-col>
                </v-row>
              </v-col>
              <!-- END DVVC  -->
              <v-col
                cols="12"
                lg="12"
                class="light-gray pa-1 pa-1"
              >
                <v-textarea
                  ref="refNotes"
                  v-model="saleOrder.note"
                  rows="1"
                  label="Ghi chú"
                  class="font-2em"
                  clearable
                />
              </v-col>
            </v-col>
          </v-tab-item>
          <!-- End Van chuyen -->

          <!-- Thanh Toan -->
          <v-tab-item class="tab-item-sale ml-4 mr-3">
            <!-- <v-row class="pt-0 ma-0 pb-0">
                <v-radio-group v-model="saleOrder.payment_type" row class="mt-0 pt-3 mb-0 pay-radio">
                  <v-radio label="Chuyển khoản" value="CK" class="pb-0 mb-0"/>
                  <v-radio label="Tiền mặt" value="TM"  class="pb-0 mb-0"/>
                </v-radio-group>
              </v-row> -->
            <v-row class="ml-1 mr-1 mt-2">
              <orderConfirm
                ref="orderConfirm"
                :order="this.saleOrder"
                :lst-product="this.saleOrder.saleOrderDetail"
              />
            </v-row>
          </v-tab-item>
          <!-- End Thanh Toan -->
        </v-tabs-items>
      </v-tabs>
    </div>
    <!-- </div> -->
  </v-form>
</template>

<script>
  import axios from 'axios'
  import 'vue-swipe-actions/dist/vue-swipe-actions.css'
  import config from '../../config/config.js'
  import snackbarNew from '../dashboard/component/snackbarNew'
  import dialogConfirm from '../dashboard/component/dialogConfirm'
  import dialogAlert from '../dashboard/component/dialogAlert'

  import VueNumericInput from 'vue-numeric-input'
  import { SwipeList, SwipeOut } from 'vue-swipe-actions'

  import orderConfirm from '../sales/orderConfirm'

  export default {
    layout: 'saleOrderMobile',
    components: {
      snackbarNew,
      dialogConfirm,
      dialogAlert,
      VueNumericInput,
      SwipeOut,
      SwipeList,
      orderConfirm,
    },
    props: {
      totals: {
        type: String,
        default: '0',
      },

    },
    data () {
      return {
        readonly: false,
        disabled: false,
        outlined: true,
        clearable: true,
        valueWhenIsEmpty: '0.00',
        optionsmoney: {
          locale: 'pt-BR',
          prefix: '',
          suffix: '',
          length: 11,
          precision: 0,
        },
        optionsqty: {
          locale: 'pt-BR',
          prefix: '',
          suffix: '',
          length: 11,
          precision: 0,
        },
        search: '',
        dialog: false,
        singleSelect: false,
        selected: [],
        dialogStorage: false,
        dialogConfirm: false,
        dialogAlert: false,
        pageCount: 0,
        itemPerPage: 5,
        bankList: [],
        color: null,
        colors: ['purple', 'info', 'success', 'warning', 'error'],
        top: true,
        bottom: false,
        left: false,
        right: false,
        snackbar: false,
        column: null,
        row: null,
        ipm_value: 1,
        snackbarContent:
          'Đã có lỗi hệ thống xảy ra, vui lòng kiểm tra lại hoặc liên hệ với admin!!!',
        searchDVT: '',
        searchInput: '',
        imageStore1: 'https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d',
        specs: [],
        panel: [0, 1, 2],
        selectProduct: {},
        customerModel: {
          code: '',
          name: '',
          phone: '',
          address: '',
          delivery_name: '',
          delivery_address: '',
          delivery_phone: '',
          delivery_time: '',
        },
        customerList: [],
        productCboList: [],
        productList: [],
        DVVCList: [],
        saleOrder: {
          order_code: '12-12-2020',
          order_customer_type: 'KL',
          customer_name: { id: 5, name: 'KH LẺ' },
          customer_code: '6',
          customer_address: 'Tp.HCM',
          customer_phone: '000000',
          name_delivery: '',
          address_delivery: 'Tp.HCM',
          phone_delivery: '',
          note: '',
          time_delivery: '',
          customer_id: '',
          create_user: '1',
          total: 0,
          saleOrderDetail: [],
          payment_type: 'TM',
          delivery_partner: 'SHOP',
          delivery_price: 0,
          promotion: 0,
        },

        specification: ['GÓI', 'THÙNG', 'KG', 'CÁI', 'HỘP'],
        suppiler_code: ['NCC1'],
        category: [],
        seqOb: {
          seqCode: 'SP',
          seqName: 'product_code_seq',
          seqDigitNumber: 5,
        },
        productStorageModel: {
          code: '',
          name_product: '',
          category_code: '',
          specification: '',
          net: '',
          wholesale_price: 0,
          retail_price: 0,
          quota_whosale: 0,
          quatity_inventory: 0,
          note: '',
          img_url: '{ "A": "B" }',
          real_price: 0,
          create_user: '1',
          receipt_suppiler: '',
        },
        emptyRules: [(v) => !!v || 'Vui lòng điền vào mục này'],
        numberRule: [(v) => !!v || 'Vui lòng điền vào mục này'],
        priceRule: [(v) => !!v || 'Vui lòng điền vào mục này'],
        specRule: [(v) => !!v || 'Vui lòng điền vào mục này'],
        dvtRules: [(v) => !!v || 'Vui lòng điền vào mục này'],
        emptyProductRules: [(v) => !!v || 'Chọn thêm sản phẩm ở đây'],
        recent: [
          {
            active: true,
            avatar: 'https://cdn.vuetifyjs.com/images/lists/1.jpg',
            title: 'Jason Oner',
          },
          {
            active: true,
            avatar: 'https://cdn.vuetifyjs.com/images/lists/2.jpg',
            title: 'Mike Carlson',
          },
          {
            avatar: 'https://cdn.vuetifyjs.com/images/lists/3.jpg',
            title: 'Cindy Baker',
          },
          {
            avatar: 'https://cdn.vuetifyjs.com/images/lists/4.jpg',
            title: 'Ali Connors',
          },
        ],

        // Swipe
        enabled: true,
        mockSwipeList: [
          {
            id: 0,
            title: 'Some title',
            description: 'some description',
          },
          {
            id: 1,
            title: 'Some title',
            description: 'some description',
          },
          {
            id: 2,
            title: 'Some title',
            description: 'some description',
          },
        ],
        // End Swipe

        // Tab
        tab: null,
        tab_confirm_disabled: true,
        tabs: [
          { name: 'Khách Hàng', icon: 'mdi-account-outline', index: 0 },
          { name: 'Giỏ hàng', icon: 'mdi-cart-plus', index: 1 },
          { name: 'Vận Chuyển', icon: 'mdi-truck-delivery', index: 2 },
          { name: 'Xác nhận đơn', icon: 'mdi-cash', index: 3, disabled: true },
        ],

        // End Tab
        lstBank: [],
        bankSeleted: 'TM',

      }
    },
    computed: {},
    watch: {
      totals: function (value) {
        console.log('totals', value)
      },
    },
    mounted: function () {}, // end method
    created () {
      this.getProductList()
      this.getSpecs()
      this.getCategories()
      this.getCustomerList()
      this.selectDVVC()
      this.getBanks()
    }, // end data
    methods: {
      isMobile () {
        if (
          /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
            navigator.userAgent,
          )
        ) {
          return true
        } else {
          return false
        }
      },
      formatPrice (value, tofix) {
        const val = (value / 1).toFixed(tofix).replace(',', '.')
        return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',')
      },
      snackbaralert (...args) {
        if (args === undefined || args < 3) {
          this.$refs.snackNotification.color = this.colors[4]
          this.$refs.snackNotification.snackbarContent =
            'Đã có lỗi xảy ra, vui lòng liên hệ admin'
          this.$refs.snackNotification.snackbar = true
        } else {
          this.$refs.snackNotification.color = args[0]
          this.$refs.snackNotification.snackbarContent = args[1]
          this.$refs.snackNotification.snackbar = true
        }
      },
      isNull (object) {
        console.log(object)
        if (object === undefined || object === null || object === '') {
          return true
        }
        return false
      },
      async onTabChange (clickedTab) {
        await this.$emit('onOrderTab', clickedTab)
        this.currentTab = clickedTab
        await this.$nextTick()
        if (!this.allowTabChange) this.currentTab = this.previousTab
        else this.previousTab = this.currentTab
        // TO GET TAB DATA OF CLICKED AND CURRENT TAB
        this.currentTabObject = this.tabs[this.currentTab]
        this.selectedTabObject = this.tabs[clickedTab]
        // console.log("onTabCHange");
        console.log('clickedTab', clickedTab)
        this.tabs[3].disabled = !this.validateBiz()
      },
      async getBanks () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/banks')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.lstBank = response.data.data
          })
      },
      validate () {
        const flag = false
        // Check customer
        return this.$refs.form.validate()
        this.$nextTick(function () {
          // Check product

          // Check delivery

          // Check cash

          // //Ton kho toi thieu
          // else if(!this.$refs.qtyinventory.validate()){
          //   this.$refs.qtyinventory.focus();
          // }
          // else if (!this.$refs.category.validate()) {
          //   flag = false;
          //   this.$refs.category.focus();
          // } else if (!this.$refs.suppiler.validate()) {
          //   flag = false;
          //   this.$refs.suppiler.focus();
          // }
          return flag
        })
      },
      validateBiz () {
        // Valid customer
        console.log('saleOrder', this.saleOrder)
        if (this.saleOrder == undefined) {
          return false
        }
        if (this.isNull(this.saleOrder.order_code) ||
          this.isNull(this.saleOrder.order_customer_type) ||
          this.isNull(this.saleOrder.customer_code) ||
          this.isNull(this.saleOrder.name_delivery) ||
          this.isNull(this.saleOrder.address_delivery) ||
          this.isNull(this.saleOrder.phone_delivery) ||
          this.isNull(this.saleOrder.delivery_partner) ||
          this.isNull(this.saleOrder.delivery_price) ||
          this.saleOrder.saleOrderDetail == undefined ||
          this.saleOrder.saleOrderDetail.length == 0
        ) {
          return false
        }

        return true
      // Valid product

      // Vaili transport
      },
      // validateBiz() {

      // },
      quantity (type) {
      // alert(type);
      },
      async insertStorage () {
        // console.log("Valid store ok:" + this.validate());
        // eslint-disable-next-line no-unused-vars
        const chitieu = JSON.stringify(this.chitieuModel)
        const seft = this
        this.productStorageModel.note = JSON.stringify({
          note: this.productStorageModel.note,
        })
        this.productStorageModel.specification = JSON.stringify({
          DVT: this.productStorageModel.specification,
        })
        this.productStorageModel.receipt_suppiler = JSON.stringify({
          NCC: this.productStorageModel.receipt_suppiler,
        })
        // this.productStorageModel.previous_price = this.productStorageModel.real_price;
        await axios
          .post(
            config.API_FAMILY + '/api/insertStorage',
            this.productStorageModel,
          )
          .then(function (response) {
            seft.dialog = false
            console.log('Valid store ok')
            console.log(response.data.data)
            seft.$emit('refeshList')
          })
      },
      refeshList () {
        this.dialog = false
        this.$emit('refeshList')
      },
      productChange (object) {
        const seft = this
        this.selectProduct.product_code = object.code
        this.selectProduct.price = parseFloat(object.retail_price)
        if (object !== undefined && object.specification !== undefined) {
          // this.specs = object.specification
          // debugger
          this.selectProduct.size = object.specification
        }
        console.log('Spec find by ID')
        console.log(this.specs)
        console.log('Product select')
        console.log(object)
        console.log('order_customer_type')
        console.log(this.saleOrder.order_customer_type)
        if (this.saleOrder.order_customer_type != undefined) {
          if (this.saleOrder.order_customer_type == 'KL') {
            this.selectProduct.price = parseFloat(object.retail_price)
          } else if (this.saleOrder.order_customer_type == 'KS') {
            this.selectProduct.price = parseFloat(object.wholesale_price)
          }
        }
        this.selectProduct.quanity = 1
        // this.selectProduct.amount = this.selectProduct.quanity * this.selectProduct.price
        const specObj = this.specs
          .filter((specs) => specs.id === this.selectProduct.size)
          .pop()
        console.log(
          'found_names: ' +
            this.specs
              .filter((specs) => specs.id === this.selectProduct.size)
              .pop().name +
            ' : ' +
            this.selectProduct.size,
        )

        this.addProduct()
      // quatity_inventory
      },
      amountProduct () {
        this.selectProduct.amount =
          this.selectProduct.quanity * this.selectProduct.price
        console.log(this.selectProduct)
      },
      itemQtyChange (item) {
        console.log('itemQtyChange', item)
        item.amount = item.quanity * item.price
        this.updateTotal()
      },
      async getSpecs () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getSpecs')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log('Spec')
            console.log(response.data.data)
            seft.specs = response.data.data
          })
      },
      async getProductList () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getListProduct')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            // console.log(response.data.data);
            seft.productCboList = response.data.data
          })
      },
      async getCustomerList () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getCustomers')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.customerList = response.data.data
          })
      },
      addProduct ($event) {
        const self = this
        if (
          this.selectProduct !== undefined &&
          this.selectProduct.product_code !== undefined &&
          this.selectProduct.product_code !== ''
        ) {
          // Check null DVT, Gia, SL
          if (this.isNull(this.selectProduct.size)) {
            this.snackbaralert(this.colors[4], 'Bạn chưa nhập đơn vị tính')
            this.$nextTick(function () {
              self.$refs.productDVT.focus()
            })
          } else if (this.isNull(this.selectProduct.price)) {
            this.snackbaralert(this.colors[4], 'Bạn chưa nhập giá bán')
            this.$nextTick(function () {
              this.$refs.productPrice.focus()
            })
          } else if (this.isNull(this.selectProduct.quanity)) {
            this.snackbaralert(this.colors[4], 'Bạn chưa nhập số lượng')
            this.$nextTick(function () {
              self.$refs.productQty.focus()
            })
          } else if (this.selectProduct.quanity <= 0) {
            this.snackbaralert(this.colors[4], 'Số lượng phải lớn hơn 0')
          } else {
            // Kiem tra tồn tại
            var count = 0
            var isExist = this.saleOrder.saleOrderDetail.filter((client) => {
              console.log('client')
              console.log(client)
              if (
                client.product_code.toLowerCase() ==
                self.selectProduct.product_code.toLowerCase() &&
                client.selectProduct.size == self.selectProduct.size
              ) {
                count++
              }
            })
            if (count > 0) {
              this.snackbaralert(
                this.colors[4],
                'Vui lòng cập nhật lại SL và Đơn giá',
              )
              return
            }
            this.amountProduct()
            var productItem = this.selectProduct
            console.log('productItem', productItem)
            console.log('searchInput', this.searchInput)

            productItem.product_name = this.selectProduct.product_name.name
            this.saleOrder.saleOrderDetail.push(productItem)
            this.updateTotal()
            console.log('addProduct')
            console.log(productItem)
            this.selectProduct = {}

            this.$emit('onUpdateOrder', this.saleOrder)
            this.$emit('onOrderTab', 1111)
            this.$nextTick(function () {
              this.$refs.productName.focus()
              self.selectProduct.product_name = ''
            // this.$refs.productName.value = "";
            })
          }
        } else {
          this.snackbaralert(this.colors[4], 'Bạn chưa chọn mặt hàng')
          this.$nextTick(function () {
            this.$refs.productName.focus()
          })
        }
      },
      onUpdateOrder () {
        this.$emit('onUpdateOrder', this.saleOrder)
      //  this.$emit('onOrderTab', clickedTab);
      },

      deleteProduct (item) {
        console.log('deleteProduct')
        console.log(item)
        this.saleOrder.saleOrderDetail.pop(item)
        this.updateTotal()
      },
      editProduct (item) {
        console.log('editProduct')
        // update current total
        item.amount = item.quanity * item.price
        this.updateTotal()
        console.log(item)
      },
      updateTotal () {
        // Total
        const seft = this
        let total = 0
        const newOrder = this.saleOrder.saleOrderDetail
        newOrder.forEach((object, idx) => {
          seft.saleOrder.saleOrderDetail.amount = object.price * object.quanity
          total += object.price * object.quanity
        })
        console.log('total', total)
        console.log(this.saleOrder.saleOrderDetail)
        this.saleOrder.total = total
      },
      async getCategories () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getCategories')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.category = response.data.data
          })
      },
      customerChange (object) {
        console.log('customerChange')
        console.log(object)
        // this.$refs.customerCode.text = object.id
        this.saleOrder.customer_phone = object.phone_number
        this.saleOrder.customer_address = object.address

      // this.productStorageModel.product_code = object.code
      // this.productStorageModel.quatity_inventory = object.quatity_inventory
      // this.productStorageModel.category_code = object.category_code
      // this.productStorageModel.suppiler_code = object.suppiler_code

      // this.productStorageModel.previous_price = object.real_price
      // this.productStorageModel.stock_current = object.quatity_inventory
      },

      statusConfirmTab (object) {
        console.log('this.validateBiz()', this.validateBiz())
        this.tabs[3].disabled = !this.validateBiz()
      },

      async insertCustomer (item) {
        const seft = this
        const customer = {
          name: this.saleOrder.customer_name,
          address: 'New Addesss',
          phone_number: this.saleOrder.customer_phone,
          address_final_orderm: 'address_final_orderm new',
          note: 'New note',
        }
        await axios
          .post(config.API_FAMILY + '/api/insertCustomer', customer)
          .then(function (response) {
            seft.getCustomerList()
            seft.snackbaralert(this.colors[4], 'Đã thêm mới khách hàng')
          })
      },
      chooseImage (ref) {
        if (ref === 'THUMB_1') {
          this.$refs.fileInput1.click()
        }
        if (ref === 'THUMB_2') {
          this.$refs.fileInput2.click()
        }
        if (ref === 'THUMB_3') {
          this.$refs.fileInput3.click()
        }
        if (ref === 'THUMB_4') {
          this.$refs.fileInput4.click()
        }
        if (ref === 'THUMB_5') {
          this.$refs.fileInput5.click()
        }
      },
      onSelectFile1 () {
        console.log('onSelectFile1')
        const input = this.$refs.fileInput1
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = (e) => {
            this.imageData1 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      enterClicked () {
        alert('enterClicked')
      },
      trigger () {
      // this.$refs.sendReply.click()
      },
      printOrder ($event) {
        console.log('prnt')
        console.log(this.saleOrder.saleOrderDetail)
      },
      async saveOrder ($event) {
        const seft = this
        if (this.validate()) {
          console.log('saleOrder')
          // this.saveOrder
          console.log(this.saleOrder)
          console.log(this.saleOrder.saleOrderDetail)
          await axios
            .post(config.API_FAMILY + '/api/insertOrder', this.saleOrder)
            .then(function (response) {
              console.log('Valid store ok')
              console.log(response.data.data)
              seft.$router.push({ name: 'DANH SÁCH ĐƠN HÀNG' })
            })
        }
      },
      async savePrintOrder ($event) {
        const seft = this
        if (this.validate()) {
          console.log('saleOrder')
          // this.saveOrder
          // console.log(this.saleOrder);
          // console.log(this.saleOrder.saleOrderDetail);
          let fileID = ''
          await axios
            .post(config.API_FAMILY + '/api/printSave', this.saleOrder)
            .then(function (response) {
              console.log('Valid store ok')
              debugger
              fileID = response.data.data
            // console.log(response.data.data);
            // seft.$router.push({ name: "DANH SÁCH ĐƠN HÀNG" });
            })
          await axios
            .get(config.API_FAMILY + `/api/onlyPrint/${fileID}`)
            .then(function (response) {
              // console.log("Valid store ok");
              seft.$router.push({ name: 'DANH SÁCH ĐƠN HÀNG' })
            })
        }
      },
      async selectDVVC () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/selectDVVC')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.DVVCList = response.data.data
          })
      },
      backList ($event) {
        this.$router.push({ name: 'DANH SÁCH ĐƠN HÀNG' })
      },
      copyCustomer (item) {
        this.saleOrder.name_delivery = this.saleOrder.customer_name.name
        this.saleOrder.phone_delivery = this.saleOrder.customer_phone
      },

      // Swipe
      revealFirstRight () {
        this.$refs.list.revealRight(0)
      },
      revealFirstLeft () {
        this.$refs.list.revealLeft(0)
      },
      closeFirst () {
        this.$refs.list.closeActions(0)
      },
      closeAll () {
        this.$refs.list.closeActions()
      },
      remove (item) {
        this.mockSwipeList = this.mockSwipeList.filter((i) => i !== item)
        console.log(e, 'remove')
      },
      itemClick (e) {
        console.log(e, 'item click 44')
      },
      fbClick (e) {
        console.log(e, 'First Button Click')
      },
      sbClick (e) {
        console.log(e, 'Second Button Click')
      },

      // End Swipe
      isNull (object) {
        if (object == undefined || object == null || object == '') { return true }
        return false
      },
    // onTabChange() {
    //   // if (this.currentTab === 1) {
    //   //   this.$nextTick(() => {
    //   //     this.tab = this.currentTab
    //   //   })
    //   //   return
    //   // }
    //   // this.currentTab = this.tab
    //   console.log("change")
    //    this.$emit('onTabChange', 123);
    // }
    }, // end method
  } // End exxport default
</script>
<style scroped>
.btn-control-detail .v-btn--icon.v-size--default {
  height: 25px;
  width: 25px;
}
.text-price input,
.text-qty input {
  color: red;
  font-weight: bold;
}

#productId {
  font-size: 20px;
}
.v-tabs { -ms-touch-action: none; touch-action: none; }

.lst-items{
  min-height: 200px;
  max-height: 300px;
  overflow-y: auto;
}
.pay-radio .v-input__control{
  height: 40px;
}

.rad-tab .v-input__slot{
  margin-bottom: 0px;
}
</style>
